{% extends "layouts/base.html" %}

{% block title %}
	{{ title }}
{% endblock %}

{% block content %}
	<div class="container py-2">
		<div class="row justify-content-between align-items-end">´
			<div class="col-md-4">
				<a class="btn btn btn-outline-secondary mb-3" href="/">← Back</a>
				<h3>{{ title }}</h3>
				<p class="card-text">Please review the user registration and enable the user.</p>
			</div>
			<div class="col-md-4 col-sm-6 mb-3">
				<a href="{{ keycloak_console_url }}" class="card-link">
					<div class="card">
						<div class="rounded d-flex align-items-center justify-content-between p-4">
							<div class="ms-0">
								<h5 class="card-title mb-1">User Console</h5>
								<span class="card-subtitle">Keycloak console for managing users directly in the database.</span>
							</div>
							<i class="fa fa-computer fa-3x text-muted opacity-50"></i>
						</div>
					</div>
				</a>
			</div>
		</div>
		<div class="row">
			<div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
				<table class="table table-bordered table-striped table-responsive table-hover">
					<thead class="thead-light">
						<tr>
							<th scope="col">User</th>
						</tr>
					</thead>
					<tbody>
					{% for member in registered_users %}
						<tr class="user-selection" id="user-select-{{member.keycloak_id}}">
							<td >
								<div>{{member.first_name}} {{member.last_name}}</div>
								<div style="font-size:10px">{{member.email}}</div>
							</td>
						</tr>
					{% endfor %}
					</tbody>
				</table>
			</div>
			<div class="col-xs-10 col-sm-10 col-md-10 col-lg-10 card">
				{% for member in registered_users %}
					{% if loop.first %}
						<div class="card-body user-card" id="user-{{member.keycloak_id}}">
					{% else %}
						<div class="card-body user-card d-none" id="user-{{member.keycloak_id}}">
					{% endif %}

						<h5 class="card-title">{{member.first_name}} {{member.last_name}}</h5>
						<table class="table">
							<tr>
								<td>Username:</td>
								<td>{{member.username}}</td>
							</tr>
							<tr>
								<td>Email:</td>
								<td>{{member.email}}</td>
							</tr>
							<tr>
								<td>First Name:</td>
								<td>{{member.first_name}}</td>
							</tr>
							<tr>
								<td>Last Name:</td>
								<td>{{member.last_name}}</td>
							</tr>
							<tr>
								<td>Created At:</td>
								<td>{{member.timestamp | getDateFromTimeStamp}}</td>
							</tr>
							<tr>
								<td>Keycloak ID:</td>
								<td>{{member.keycloak_id}}</td>
							</tr>
						</table>
						<h5 class="card-title">Attribute</h5>
						<table class="table">
							{% if member.attributes.keys is not undefined %}
								{% for key in member.attributes.keys() %}
									<tr>
										{%if (key | getInMapping) %}
											<td>{{(key | getInMapping)["description"]}}:</td>
										{% else %}
											<td>{{key}}:</td>
										{% endif %}
										<td>{{member.attributes[key]}}</td>
									</tr>
								{% endfor %}							
							{% endif %}
						</table>
						{% if (member | getAccess) %}
						<h5 class="card-title">Rollen & Gruppen</h5>
						<table class="table">
							<tr >
								<td>Roles:</td>
								<td id="roles-{{member.keycloak_id}}">
									{% for role in (member | getAccess) %}
									<div class="form-check">
										<input class="form-check-input" 
											id="{{role['key']}}" 
											type="checkbox" 
											name="{{role['input']}}" 
											data-value-group="{{role['value-group']}}" 
											data-value-role="{{role['value-role']}}" 
											{{role['checked']}}>
										<label class="form-check-label" for="{{role['key']}}">{{role['name']}}</label>
									</div>
									{% endfor %}
								</td>
							</tr>
						</table>
						{% endif %}
						{% if groups_opt_in is not undefined %}
						<h5 class="card-title">Groups</h5>
							{% for group in groups_opt_in %}
								<div class="{{group.title}}-form-check">
									<label class="form-check-label" for="{{group.title}}-opt-in">{{group.title}}</label>
									<input class="form-check-input group-checkbox" 
										id="{{group.title}}-opt-in-check" 
										type="checkbox" 
										name="opt-in-{{group.path}}" 
										data-value-group="{{group.title}}" 
										data-value-role="{{group.title}}-value">

								</div>
								<br />
							{% endfor %}
						{% endif %}
						<div class="btn-group" role="group">
							<button class="btn btn-success enableUser btn-sm" id="btn-enable-user-{{member.keycloak_id}}" data-bs-toggle="tooltip" data-bs-placement="top" title="Enable User"><i class="fa fa-check"></i></button>
							<!-- Button trigger modal -->
							<button type="button" class="btn btn-danger btn-sm" data-bs-toggle="modal" data-keycloakid="{{member.keycloak_id}}"  data-bs-target="#declineModal">
								<a data-bs-toggle="tooltip" data-bs-placement="top" data-bs-placement="top" title="Remove User">
									<i class="fa fa-xmark"></i>
								</a>
							</button>
						</div>

					</div>
					{% endfor %}
					
						<!-- Button trigger modal -->
						<!-- Modal -->
						<div class="modal fade" id="declineModal" tabindex="-1" aria-labelledby="declineModalLabel" aria-hidden="true">
							<div class="modal-dialog">
								<div class="modal-content">
									<div class="modal-header">
									<h1 class="modal-title fs-5" id="declineModalLabel">Wollen Sie den Zugangsantrag des Nutzers ablehnen?</h1>
									<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
									</div>
									<div class="modal-body">
										<form role="form" id="declineModalForm">
											<div class="form-group">
												<label class="control-label col-md-3">Begründung</label>
												<textarea class="form-control" id="reason" rows="5"></textarea>
												<input type="text" class="form-control" id="keycloak-id" style="display:none">

											</div>
										</form>
											<div class="modal-footer">
												<button type="button" class="btn btn-success btn-remove-user" id="btn-disable-user" data-bs-toggle="tooltip" data-bs-placement="top" title="Remove User"
												onclick="remove_user()">Speichern</button>
											</div>
									</div>
								</div>
							</div>
						</div>
				</div>
		</div>
	</div>
{% endblock %}

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}
<script>
	$(document).ready(function() {
    	// Uncheck all checkboxes with the class 'group-checkbox' on page load
    	$('.group-checkbox').prop('checked', false);
	});
	var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
	var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
		return new bootstrap.Tooltip(tooltipTriggerEl)
	})

	$('#declineModal').on('show.bs.modal', function (event) {
		console.log("modal")
		var button = $(event.relatedTarget) // Button that triggered the modal
		var recipient = button.data('keycloakid') // Extract info from data-* attributes
		// If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
		// Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
		var modal = $(this)
		modal.find('#keycloak-id').val(recipient)
	  })

	$(".enableUser").click(function(event) {
		event.preventDefault();
		const keycloak_id = this.id.replace("btn-enable-user-", "");

		console.log(keycloak_id)

		const roles = $(`#user-${keycloak_id}`).find(`#roles-${keycloak_id}`)
		const groups = $(`#user-${keycloak_id}`).find(`#groups-${keycloak_id}`)

		console.log(roles)
		console.log(groups)

		/* get all roles */
		var selectedRoles = [];
		var selectedGroups = [];
		roles.find("input:checked").each(function(){
			selectedRoles.push($(this).data('value-role'));
			selectedGroups.push($(this).data('value-group'));
		});

		// Loop over each checkbox with the class 'group-checkbox'
		$(".group-checkbox").each(function() {
			// Check if the current checkbox is checked
			var isChecked = $(this).is(":checked");
			
			var groupName = $(this).attr('name').split('opt-in-').pop();
			
			if (isChecked) {
				console.log("Group Checkbox is checked: ", groupName);
				selectedGroups.push(groupName);
			}
		});
		

		console.log(selectedRoles)
		console.log(selectedGroups)
		
		$.ajax({
			type: "POST",
			url: "{{ url_for('users_registration_review_blueprint.api_enable_user') }}",
			data: JSON.stringify({
				"keycloak_id": keycloak_id,
				"roles": selectedRoles,
				"groups": selectedGroups
			}),
			processData: false,
			contentType: 'application/json',
			success: function(response) {
				if (response.message == "success") {
					console.log("response: ", response)
					location.reload()
				}
			},
			error: function() {
				alert("SOMETHING WRONG!")
			}
		})
	});

	function remove_user() {
		event.preventDefault();
		const keycloak_id = $('#keycloak-id').val()
		const reason_for_decline = $('#reason').val()

		console.log(reason_for_decline)

		$.ajax({
			type: "POST",
			url: "{{ url_for('users_registration_review_blueprint.api_disable_user') }}",
			data: JSON.stringify({
				"keycloak_id": keycloak_id,
				"reason_for_decline" : reason_for_decline
			}),
			processData: false,
			contentType: 'application/json',
			success: function(response) {
				if (response.message == "success") {
					location.reload()
				}
			},
			error: function() {
				alert("SOMETHING WRONG!")
			}
		})
	}

	$(".user-selection").click( function(event) {
		event.preventDefault();
		const keycloak_id = this.id.replace("user-select-", "");
		$(".user-card").addClass("d-none")
		$(`#user-${keycloak_id}`).removeClass("d-none")
	});


	
	/*$("#declineModalForm").validate({
		rules: {
		  reason: {
			required: true,
			minlength: 8
		  },
		  action: "required"
		},
		messages: {
		  reason: {
			required: "Please enter some data",
			minlength: "Your data must be at least 8 characters"
		  },
		  action: "Please provide some data"
		}
	  });*/
</script>

{% endblock javascripts %}
